<template>
  <div :class="{ 'is-loading': isShowLoader }">
    <SectionHeading
      :task="task"
      :is-show-loader="isShowLoader"
      :header-sections="headerSections"
    />

    <template v-if="isParticipant">
      <SectionTab
        v-for="(risk, i) in riskTableInfo"
        :key="i"
        :title="risk.requisiteGroupTitle"
        :big-title="true"
      >
        <table
          class="task-monitor-table"
          cellpadding="0"
          cellspacing="0"
        >
          <tr
            v-for="(field, i) in risk.fields"
            :key="i"
          >
            <td width="40%">
              {{ field.fieldTitle }}
            </td>
            <td width="50%">
              <span
                v-for="(fieldValue, index) of field.fieldValues"
                :key="index"
              >
                <template v-if="fieldValue.isPriority">
                  <template v-if="fieldValue.data.valueType === 'CHECKLIST_LIST'">
                    <ObShowMore>
                      <div
                        v-for="(item, index) in fieldValue.data.valuesTitled"
                        :key="index"
                      >
                        {{ item.code || item.articleNumber }} - {{ item.title }}
                      </div>

                    </ObShowMore>
                  </template>

                  <template v-else-if="fieldValue.data.valueType === 'BOOLEAN'">
                    <ObCheckbox
                      class="itemSave"
                      :disabled="true"
                      :value="fieldValue.data.value"
                    />
                  </template>

                  <template v-else>
                    <span v-html="fieldValue.data.value" />
                  </template>
                </template>
              </span>
            </td>
            <td width="10%">
              <i
                v-if="field.fieldRisks[0]"
                :class="[ 'icon risk-icon', getRiskClass(field.fieldRisks[0].riskGroupColor) ]"
              />
            </td>
          </tr>
        </table>
      </SectionTab>
    </template>

    <div class="task-monitor-gutter">
      <div class="form-row form-halfed-wrapper">
        <div class="form-halfed-block">
          <ObInput
            :label="activityTitle"
            :readonly="true"
            :preIcon="getRiskClass(assignedRisk)"
            :disabled="!isNewTask"
            v-model="assignedRiskTitle"
          />
        </div>

        <div class="form-halfed-block">
          <ObSelector
            label="Уровни риска"
            :items="risksList"
            :disabled="!isNewTask"
            v-model="selectedRisk"
          />
        </div>

        <div
          v-if="isCommentVisible"
          class="form-full-block"
        >
          <ObTextarea
            label="Комментарий"
            :disabled="!isNewTask"
            v-model="comment"
          />
        </div>
      </div>
    </div>

    <div
      v-if="isNewTask"
      class="task-monitor-gutter task-monitor-buttons-container"
    >
      <ObButton
        :disabled="isSubmitDisabled"
        @click="onSave"
        label="Подтвердить"
      />
    </div>
  </div>
</template>

<script>
  import ObShowMore from 'common-components/src/obComponents/obShowMore'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObSelector from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import riskIconMixin from '@/mixins/risk-icon'
  import { COLORS as RISK_COLORS } from '@/resources/risk_colors'
  import { TITLES as RISK_TITLES } from '@/resources/risk_titles'
  import api from '@/api'
  import { groupsFieldsSort } from '@/helpers/fields'
  import SectionMixin from './SectionMixin'

  export default {
    name: 'sectionAssessmentRisk',
    mixins: [
      riskIconMixin,
      SectionMixin
    ],
    components: {
      ObInput,
      ObSelector,
      ObButton,
      ObCheckbox,
      ObTextarea,
      ObShowMore
    },
    data () {
      return {
        risksList: [],
        assignedRisk: '',
        assignedRiskUuid: null,
        assignedRiskTitle: '',
        selectedRisk: '',
        activityTitle: '',
        comment: '',
        RISK_COLORS
      }
    },
    watch: {
      async task () {
        if (Object.keys(this.task).length === 0) {
          return
        }

        await this.loadForm()
      }
    },
    async created () {
      await this.loadForm()
    },
    computed: {
      isCommentVisible () {
        return this.selectedRisk && this.assignedRiskUuid !== this.selectedRisk
      },
      isSubmitDisabled () {
        return !this.selectedRisk || (this.isCommentVisible && !this.comment)
      },
      riskTableInfo ({ headerData }) {
        if (!headerData) {
          return {}
        }

        return headerData.groups ? groupsFieldsSort(headerData.groups) : {}
      }
    },
    methods: {
      async loadForm () {
        this.isLoading = true

        await this.getRisk()

        this.isLoading = false
      },
      async getRisk () {
        try {
          const response = await (
            this.isParticipant
              ? api.taskMonitor.getCarrierRiskCard(this.task.card_uuid, this.task.uuid)
              : api.taskMonitor.getResourceCurrentRiskAssessment(this.task.card_uuid)
          )

          this.activityTitle = this.isParticipant ? response.data.activityTitle : 'Текущая оценка'
          this.assignedRisk = this.isParticipant ? response.data.systemRiskCode.riskColor : response.data.risk_group_color
          this.assignedRiskUuid = this.isParticipant ? response.data.systemRiskCode.riskUuid : response.data.risk_group_uuid
          this.assignedRiskTitle = RISK_TITLES[this.assignedRisk]

          try {
            const { data } = await (
              this.isParticipant
                ? api.taskMonitor.getCarrierRiskCardAssessment(this.task.card_uuid, this.task.uuid)
                : api.taskMonitor.getResourceRiskGroup()
            )

            this.risksList = data[this.isParticipant ? 'assessments' : 'risk_group'].map(r => {
              return {
                icon: this.getRiskClass(this.isParticipant ? r.riskColor : r.risk_group_color),
                title: RISK_TITLES[this.isParticipant ? r.riskColor : r.risk_group_color],
                uuid: this.isParticipant ? r.riskUuid : r.risk_group_uuid
              }
            })

          } catch (e) {
            throw(e)
          }
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },
      async onSave () {
        let notificationId = new Date().getTime() + 'save'
        this.$notification({ type: 'system_notification_in_load', message: 'Сохранение', id: notificationId })

        try {
          // >>> Posting task payload
          try {
            const payload = {
              riskUuid: this.selectedRisk,
              risk_uuid: this.selectedRisk,
              comment: this.comment
            }

            const response = await (
              this.isParticipant ?
                api.taskMonitor.postCarrierRiskCard(this.task.card_uuid, this.task.uuid, payload)
                : api.taskMonitor.postResourceRiskGroup(this.task.card_uuid, payload)
            )

            if (response && response.error) throw `Ошибка при сохранении данных: ${response.error}`

          } catch(e) {
            throw(e)
          }

          // >>> Archiving task
          try {
            const res = await api.taskMonitor.postTaskExecuted(this.task.uuid, this.userUuid)
            if (res && res.error) throw `Ошибка архивации задачи: ${res.error}`

          } catch (e) {
            throw e
          }

          this.onTaskSuccess()
          this.onClose()

        } catch(e) {
          console.error(e)

          this.$notification({ type: 'system_notification_error', message: e })
        }

        this.$notification({ event: 'close', id: notificationId })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  $risk-yellow: $gorse-yellow;
  $risk-blue: $light-denim;
  $risk-green: $color-green-light;
  $risk-orange: $taskMonitorPage-risk-orange;
  $risk-red: $taskMonitorPage-risk-red;
  $risk-black: $taskMonitorPage-risk-black;

  .task-monitor-gutter {
    padding: 0 40px;
  }

  .form-halfed-block {
    &::v-deep {
      .risk-icon-YELLOW {
        color: $risk-yellow;
      }

      .risk-icon-BLUE {
        color: $risk-blue;
      }

      .risk-icon-GREEN {
        color: $risk-green;
      }

      .risk-icon-ORANGE {
        color: $risk-orange;
      }

      .risk-icon-RED {
        color: $risk-red;
      }

      .risk-icon-BLACK {
        color: $risk-black;
      }
    }
  }

  .task-monitor-table {
    width: 100%;
    border-collapse: collapse;

    tr {
      border-bottom: 1px $lavender solid;

      &:last-child {
        margin-bottom: -1px;
      }
    }

    td {
      padding-top: 8px;
      padding-bottom: 8px;
      vertical-align: middle;
      padding-left: 27px;

      &:last-child {
        padding-left: 0;
        text-align: center;
        background-color: $background-color-light;
      }
    }

    .risk-icon {
      font-size: 18px;
    }
  }

  .task-monitor-buttons-container {
    display: flex;
    justify-content: flex-end;
    margin-top: 40px;
  }

  .form-halfed-wrapper {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
  }

  .form-halfed-block {
    width: calc(50% - 10px);
    margin-bottom: 20px;
  }

  .form-full-block {
    width: 100%;
    margin-bottom: 20px;
  }

  .form-tab + .task-monitor-gutter {
    margin-top: 20px;
  }

  ::v-deep .form-tab-content {
    margin-top: 0;
  }
</style>
